import argparse
import json
import logging
import os
import re
import sys
import codecs
import copy
import string

defaultencoding = 'utf-8'
datapath='/home/user1/fall2019/data'
inputfile='deposition_record_keys_full_test.txt'
#inputfile='deposition_record_key_1.txt'
logfile="file2jsonTest.log"
output_dict='article_json_line'

import sys

defaultencoding = 'utf-8'



#init function
def Init():
  formatter_str = '%(asctime)s - %(name)s - %(levelname)s - %(message)s'
  log_level = logging.INFO
  logging.basicConfig(filename=logfile, format=formatter_str, level=log_level)
  logger = logging.getLogger(__name__)
  return logger

#convert content of file to json file
def file2Json(filename):
  if (len(filename) <= 8):
    return None
  if not os.path.isfile(filename):
    #logger.warning(filename + " does not exist")
    return None
  pages = {}
  pages["text_content"] = []
  with open(filename, 'r') as fp:
    lines = fp.readlines()
    #if len(lines) < 25:
    #  logger.warning("error format for file" + filepath)
    pageNum = 1
    currentPageNumString = pageNum #"{:0>5}".format(pageNum)
    nextPageNumString = pageNum+1 #"{:0>5}".format(pageNum+1)
    pageContent = u""
    match = False
    page = {}
    line_dict = {}
    #curr  line num = 1
    #next line num = curr + 1 
    #page[line_content] = []
    curr_line_num = 1
    next_line_num = curr_line_num + 1
    page["line_content"] = []

    for line in lines[0:]:
      #line1 = {}
      line = line.strip()
      line = re.sub(r'"', '', line)
      line = line.lstrip(string.punctuation)
      line = line.replace('\t', ' ')
      try:
        line.decode()
      except UnicodeDecodeError:
        continue
      res = re.match('^25', line)
      if (res):
        match = True
      if (len(line) == 0 and match) or 'pgNbr' in line :
          page["page"] = currentPageNumString
          page["content"] = pageContent   
          pages["text_content"].append(copy.deepcopy(page))          
          pageNum += 1
          currentPageNumString = nextPageNumString
          #nextPageNumString = "{:0>5}".format(pageNum+1)
          nextPageNumString = pageNum+1
          #curr line num = 0
          #next line num = 0 
          curr_line_num = 1
          next_line_num = curr_line_num + 1
          pageContent = ""
          page["line_content"] = []   
          line_dict = {}
          match = False
      else:
        try:
          if (line.isdigit()):
            continue
          pageContent += line
          pageContent += ' '
          #line_dict = {}
          #line_dict[num] = curr page num 
          #line_dict[conent] = line
          #page[line_content].append(copy.deepcopy(line1))
          #curr line num = next 
          #next line num = next + 1 
          line_dict["line_number"] = curr_line_num
          line_dict["content"] = line
          #added content 
	  if (len(line) > 0 and line[0].isdigit()):
            if (len(line) > 1 and line[1].isdigit()):
              line_dict["actual_number"] = int(line[0:2])
            else:
              line_dict["actual_number"] = int(line[0])
	  else :
	    line_dict["actual_number"] = None
          page["line_content"].append(copy.deepcopy(line_dict))
          line_dict["content"] = []
          #line_dict = {}
          curr_line_num = next_line_num
          next_line_num = curr_line_num + 1 


        except UnicodeDecodeError:
          continue
  return pages

def dump2File(outfilename, page):
  if ( not page):
    return
  outfilename = output_dict+'/'+outfilename
  out = codecs.open(outfilename, 'w', 'utf8')
  try:
    out.write(json.dumps(page, indent = 4, sort_keys=True, ensure_ascii=False))
  except UnicodeDecodeError:
    logger.warning("unicode decode error")
  out.close()

#convert record_key to the path of file
def getFileName(line):
  line = line.strip()
  if len(line) != 8:
    #logger.warning ("error format " + line)
    return None

  filepath = datapath
  for i in range(0, 4):
    filepath = filepath + '/' + line[i]
  filename = filepath + '/' + line + '/' + line + '.ocr'
  return filename



if __name__ == "__main__":

  if sys.getdefaultencoding() != defaultencoding:
    reload(sys)
    sys.setdefaultencoding(defaultencoding)
  logger  = Init()
  logger.info("begin processing...")
  with open(inputfile,'r') as fp:
    lines = fp.readlines()
    for line in lines:
      filename = getFileName(line)
      page = file2Json(filename)
      dump2File(line.strip(), page)
